apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "tuf.fullname" . }}-targets
  labels:
    {{- include "tuf.labels" . | nindent 4 }}
    rugged-worker: targets
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.targets.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "tuf.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations:
        checksum/config: {{ include (print $.Template.BasePath "/configmap-targets.yaml") . | sha256sum }}
      {{- with .Values.podAnnotations }}
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.targets.podAnnotations }}
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "tuf.selectorLabels" . | nindent 8 }}
    spec:
      volumes:
        - name: signing-keys
          persistentVolumeClaim:
            claimName: {{ include "tuf.fullname" . }}-signingkeys
        - name: tuf-repo
          persistentVolumeClaim:
            claimName: {{ include "tuf.fullname" . }}-tufrepo
        - name: verification-keys
          persistentVolumeClaim:
            claimName: {{ include "tuf.fullname" . }}-vkeys
        - name: incoming-targets
          persistentVolumeClaim:
            claimName: {{ include "tuf.fullname" . }}-targets
        - name: targets-cm
          configMap:
            name: {{ include "tuf.fullname" . }}-targets-cm
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "tuf.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: worker
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          {{- with .Values.targets.env }}
          env:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          resources:
            {{- toYaml .Values.targets.resources | nindent 12 }}
          volumeMounts:
            - mountPath: /var/rugged/tuf_repo
              name: tuf-repo
            - mountPath: /var/rugged/incoming_targets
              name: incoming-targets
            - mountPath: /var/rugged/signing_keys/targets
              name: signing-keys
              subPath: targets
              readOnly: true
            - mountPath: /var/rugged/signing_keys/bins
              name: signing-keys
              subPath: bins
              readOnly: true
            - mountPath: /var/rugged/verification_keys
              name: verification-keys
              readOnly: true
            - mountPath: /etc/rugged
              name: targets-cm
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
